#ifndef __DTMF_H__
#define __DTMF_H__

#define PI (float)			3.1415926535

#define SAMPLINGRATE		8000    /* Sampling rate */
#define DTMF_NPOINTS		205     /* Number of samples for DTMF recognition     */
#define NDTMFCOEFF			8				/* Number of frequencies to be analyzed       */
#define NDIGIT					16	    /* Number of DTMF digits                      */
#define DTMF_TRESH			4000    /* Above this is dtmf                         */
#define SILENCE_TRESH   200     /* Below this is silence                      */
#define AMP_BITS        9				/* Bits per sample, reduced to avoid overflow */


#define NODTMF 0xff

#define NTONECOEFF			2				/* Number of frequencies to be analyzed       */
#define TONE_NPOINTS		205     /* Number of samples for tone recognition     */
#define TONE_TRESH			4000    /* Above this is tone                         */


u08 DTMFprocess( s32 *DTMFsamples );
u08 DTMFdecode(void);
void DTMFactivate( void );
u08 DialToneprocess( s32 *ToneSamples );
void TONEactivate( void );
s08 TONEdecode(void);


#endif

