
#include <stdio.h>
#include "uip.h"
#include "httpd.h"
#include "fs_fat.h"
#include "fsdata.h"
#include "typedefs.h"
#include "fatlib.h"

#ifndef NULL
#define NULL (void *)0
#endif



u08 sHTTP_OK[]   = "HTTP/1.0 200 OK\r\n";
u08 sHTTP_NOTOK[]= "HTTP/1.0 404 File not found\r\n";
u08 sSERVER[]    = "Server: uIP/0.9 (http://dunkels.com/adam/uip/)\r\n";
u08 sHTML[]      = "Content-type: text/html\r\n";
u08 sGIF[]       = "Content-type: image/gif\r\n";
u08 sPNG[]       = "Content-type: image/png\r\n";
u08 sJPEG[]      = "Content-type: image/jpeg\r\n";
u08 sWAVE[]      = "Content-type: audio/x-wav\r\n";
u08 sPLAIN[]     = "Content-type: text/plain\r\n";
u08 sLENGTH[]    = "Content-Length: ";
/*-----------------------------------------------------------------------------------*/
static u8_t
fs_strcmpext(const char *str1, const char *str2)
{
  if ( (str1[0] == str2[0]) && (str1[1] == str2[1]) && (str1[2] == str2[2]) )
  {
    return 1;
  } else {
    return 0;
  }
}
/*-----------------------------------------------------------------------------------*/
static u16 fs_strcopy(char *str1, char *str2)
{
  u16 index = 0;

  while ( str2[index] != 0 ) {
    str1[index] = str2[index];
    index++;
  }
  return index;
}
/*-----------------------------------------------------------------------------------*/

int
fs_open(const char *name, struct fs_file *file, char *fileBuffer)
{
  u16 length, readfromfile;
  s08 fHandle;

  u08 index;
  u08 size[20];
  u32 filesize;

 /* Remove the starting '/' */
  if (name[0] == '/') name++;

  fHandle = fat_openRead(name);
  if  (fHandle >= 0) {
    length =  fs_strcopy(&fileBuffer[0], sHTTP_OK);
  } else {
    length =  fs_strcopy(&fileBuffer[0], sHTTP_NOTOK);
    name = "404.htm";
    fHandle = fat_openRead(name);
  }

  length += fs_strcopy(&fileBuffer[length], sSERVER);

  /* Find the "." in the name */
  index = 0;
  while (name[index] != '.') {
    index++;
  }
  index++;
  
  if (fs_strcmpext( &name[index], "htm") )
  {
    length += fs_strcopy(&fileBuffer[length], sHTML);
  } else if (fs_strcmpext( &name[index], "png") )
  {
    length += fs_strcopy(&fileBuffer[length], sPNG);
  } else if (fs_strcmpext( &name[index], "gif") )
  {
    length += fs_strcopy(&fileBuffer[length], sGIF);
  } else if (fs_strcmpext( &name[index], "jpg") )
  {
    length += fs_strcopy(&fileBuffer[length], sJPEG);
  } else if (fs_strcmpext( &name[index], "wav") )
  {
    length += fs_strcopy(&fileBuffer[length], sWAVE);
  } else {
    length += fs_strcopy(&fileBuffer[length], sPLAIN);
  }
  
  /* Add the Content-Length header */
  length += fs_strcopy(&fileBuffer[length], sLENGTH);
  filesize = fatFindFileSizeRead(fHandle);
  /* Put the right size in the file */
  sprintf(size,"%ld \r\n",filesize);
  length += fs_strcopy(&fileBuffer[length], size);
  /* Finish with crlf */
  length += fs_strcopy(&fileBuffer[length], "\r\n");

  do {
    readfromfile = fat_read(fHandle, &fileBuffer[length], 256 );
    length += readfromfile;
  }
  while ( ( readfromfile != 0) && (length < (FILEBUFFERSIZE-256)) );
  
  file->data = &fileBuffer[0];
  file->len = length;	
  if (readfromfile == 0) {
    fat_close(fHandle);
    file->handle = 0x80;
  } else {
    file->handle =fHandle;
  }
  return 1;
}
/*-----------------------------------------------------------------------------------*/
