//*****************************************************************************
// File Name	: mmctest.c
// 
// Title		: example usage of mmc functions
// Revision		: 1.0
// Notes		:	
// Target MCU	: Atmel AVR series
// Editor Tabs	: 4
// 
// Revision History:
// When			Who			Description of change
// -----------	-----------	-----------------------
// 20-SEP-2004	pstang		Created the program
//*****************************************************************************


//----- Include Files ---------------------------------------------------------

#include <stdio.h>
#include <string.h>
#include "globalsd.h"		// include our global settings
#include "mmc.h"		// include MMC card access functions
#include "fatlib.h"
#include "dtmf.h"
#include "config.h"

void mmcTest(void);
s08 tamtam( void );
int ReadWriteTest();
extern u08 memCardInit();

extern s32 DTMFsample1[DTMF_NPOINTS];	/* Pointer to DTMF samples - Ping */
extern s32 DTMFsample2[DTMF_NPOINTS];	/* Pointer to DTMF samples - Pong */

extern s32 *p_DTMFsample;          		/* Current pointer to the DTMF sample  - Ping*/
extern s32 *p_DTMFend;					  		/* End pointer to the wave sample */

extern u08 DTMFbufferReady;						/* Indicates if buffer 1 or 2 is ready for processing */
extern volatile u08 dspmode;
extern u08 DTMFearly;

extern u08 cidBytes[48];


s08 playWaveFile(u08 *filename);
s08 recordWaveInit(u08 *filename);
void recordWave( s08 hWave );
void recordWaveEnd( s08 hWave );


// Print a part of memory as a formatted hex table with ascii translation
void debugPrintHexTable(u16 length, u08 *buffer)
{
	u08 i;
	u16 j;
	u08 *buf;
	u08 s;

	buf = buffer;
	
	// print the low order address indicies and ASCII header
	printf("     00 01 02 03 04 05 06 07 08 09 0A 0B 0C 0D 0E 0F  0123456789ABCDEF\r\n");
	printf("     -----------------------------------------------  ---- ASCII -----\r\n");

	
	// print the data
	for(j=0; j<((length+15)>>4); j++)
	{
		// print the high order address index for this line
		printf("%04x",j<<4);
		printf("-");
 
		// print the hex data
		for(i=0; i<0x10; i++)
		{
			// be nice and print only up to the exact end of the data
			if( ((j<<4)+i) < length)
			{
				// print hex byte
				printf("%02X",buf[(j<<4)+i]);
				printf(" ");
			}
			else
			{
				// we're past the end of the data's length
				// print spaces
				printf("   ");
			}
		}
		
		// leave some space
//		printf(" ");
		// print the ascii data
		for(i=0; i<0x10; i++)
		{
			// be nice and print only up to the exact end of the data
			if( ((j<<4)+i) < length)
			{
				// get the character
				s = buf[(j<<4)+i]; 
				// make sure character is printable
				if(s >= 0x20)
				{
//					printf("%c",s);
				
				 } else	{
//					printf(".");
				 }
			} else {
				// we're past the end of the data's length
				// print a space
//				printf(" ");
			}
		}
//		printfCRLF();
		printf("\n");
	}

}

	// initialize our libraries
	// initialize the UART (serial port)
//	uartInit();
//	uartSetBaudRate(115200);
	// make all rprintf statements use uart for output
//	rprintfInit(uartSendByte);
	// initialize the timer system
//	timerInit();
	// initialize vt100 terminal
//	vt100Init();

//	timerPause(100);

	// print welcome message
//	vt100ClearScreen();
//	vt100SetCursorPos(1,0);
//	rprintfProgStrM("\r\nWelcome to the MMC Test Suite!\r\n");

//	timerPause(1000);

//	mmcTest();

//	return 0;

int ReadWriteTest(void)
{
  signed int stringSize;
  signed char handle;
  char stringBuf[100];
  signed int ret;

  handle = fat_openRead("tam.txt");
	printf("Handle: %d \n",handle);
	if (handle >= 0)
    {
        stringSize = fat_read(handle, stringBuf, 99);
        stringBuf[stringSize] = '\0';
        printf("String: %s",stringBuf);
        fat_close(handle);
    }

  handle = fat_openWrite("goodbye.txt");
	printf("Handle: %d \n",handle);
    if (handle >= 0)
    {
        strcpy(stringBuf, "Goodbye World!");
        stringSize = strlen(stringBuf);
        ret = fat_write(handle,stringBuf, stringSize);
        printf ("Return from write: %d \n",ret);
        fat_flush();    
        fat_close(handle);
    }
return 0;
}

void mmcTest(void)
{
	u32 sector=0;
	u08 buffer[0x200];
	int c;
  int i;
  u08 digit;

  s08 hWave;
  u16 dialtonecounter;
  s08 dialdetect;

	// print new prompt
	printf("\r\ncmd>");

	// testing loop
	while(1)
	{
		// check for keypress
		if((c=getchar()) != -1)
		{
			switch(c)
			{
			case 'i':
				// initialize card 
				printf("\r\nResetting MMC/SD Card\r\n");
//				mmcReset();
				if (memCardInit())
					printf("yes \n");
					else
					printf("No \n");
				break;
			case 'r':
				// read current sector into buffer
				printf("\r\nRead Sector %lu\r\n", sector);
				mmcRead(sector, buffer);
				// print buffer contents
//				debugPrintHexTable(0x200, buffer);
				debugPrintHexTable(0x200, buffer);
				break;
			case 'w':
				// write current sector with data from buffer
				printf("\r\nWrite Sector %lu\r\n", sector);
				mmcWrite(sector, buffer);
				break;
			// move to new sector
			case 'a':
				ReadWriteTest();
				break;

      case 'c':
        printf("Caller ID detection \n");
        dspmode = FSKINIT;
        while ( dspmode != IDLE) 
        {
          i = i+ dspmode;
//           if ( getchar() != -1)
//          {
//            DTMFearly = 0x55;
//          }
        }
 //       if (cidChecksum == 0)
//        {
        printf("\nDate: %c%c/%c%c\n",cidBytes[4],cidBytes[5],cidBytes[6],cidBytes[7]);
        printf("Time: %c%c:%c%c\n",cidBytes[8],cidBytes[9],cidBytes[10],cidBytes[11]);
        printf("Number: ");
        for (i=14; i<24; i++)
        {
          printf("%c",cidBytes[i]);
        }
          printf("\n");
//      }      
        printf("Caller ID detection end\n");
        break;

      case 'v':
        printf("End Caller ID \n");
        dspmode = FSKEND;
        while (dspmode != IDLE)
        {
          i=i+1;
        }
       printf("Mode: %d\n",dspmode);
       break;

			case 'p':
			  /* OFF HOOK */
        IOCLR1  = OFFHOOK;
        playWaveFile("hello.wav");
        /* On HOOK */
        IOSET1  = OFFHOOK;
        break;
 
 			case 't':
				
        tamtam();
				break;

			case 'o':
        hWave = fat_openRead("temp.wav");
        printf("Open Read: %d \n",hWave);
        if (hWave >= 0)
        {
          fat_close(hWave);
          hWave = fat_delete("temp.wav");
          printf("Delete: %d \n",hWave);
        }

				hWave = recordWaveInit("temp.wav");
        recordWave(hWave);
        recordWaveEnd(hWave);
        break;

			case 'd':
        printf("DTMF detection\n");
        DTMFactivate();
        while ( (digit = DTMFdecode()) == NODTMF )
        {
        }
        printf("Decoded: %c\n",digit);
			  break;
 		
    	case 'k':
			  /* OFF HOOK */
        printf("Going Off Hook\n");
        IOCLR1  = OFFHOOK;
        while (getchar() == -1) {};
          /* On HOOK */
          printf("Going On Hook\n");
          IOSET1  = OFFHOOK;
          break;

      case 'b':
        printf("Dial Tone detection\n");
			  /* OFF HOOK */
        printf("Going Off Hook\n");
        IOCLR1  = OFFHOOK;
        TONEactivate();
        dspmode = DTMFDETECT;

        while (!(U1LSR & 0x01)) {
          dialtonecounter = 0;
          while (dialtonecounter < 40) {
            dialdetect = TONEdecode();
            if (dialdetect != -1) {
              if (dialdetect == 2) {
                dialtonecounter++;
              } else {
                dialtonecounter = 0;
              }
            }
          }
          printf("Dial Tone detected\n");
        }
        dspmode = IDLE;
        printf("Tone detected\n");
        /* On HOOK */
        printf("Going On Hook\n");
        IOSET1  = OFFHOOK;
			  break;


			case 'x':
        return;

			case '+': sector++;		printf("\r\nSector = %lu", sector); break;
			case '-': sector--;		printf("\r\nSector = %lu", sector); break;
			case '*': sector+=512;	printf("\r\nSector = %lu", sector); break;
			case '/': sector-=512;	printf("\r\nSector = %lu", sector); break;
			case '\r':
			default:
				break;
			}
			// print new prompt
			printf("\r\ncmd>");
		}
	}


}
