/******************************************************************************/
/*  This file is part of the uVision/ARM development tools                    */
/*  Copyright KEIL ELEKTRONIK GmbH 2002-2004                                  */
/******************************************************************************/
/*                                                                            */
/*  SERIAL.C:  Low Level Serial Routines                                      */
/*                                                                            */
/******************************************************************************/

#include <LPC213x.H>                     /* LPC21xx definitions               */

#define CR     0x0D



/* Read character from Serial Port   */
int getchar (void)
{                    

  while (!(U1LSR & 0x01));
	return (U1RBR);
}

int putchar (int ch)  {                  /* Write character to Serial Port    */

  if (ch == '\n')  {
    while (!(U1LSR & 0x20));
    U1THR = CR;                          /* output CR */
  }
  while (!(U1LSR & 0x20));
  return (U1THR = ch);
}  

void init_serial (void)  {               /* Initialize Serial Interface       */
  U1LCR = 0x83;                          /* 8 bits, no Parity, 1 Stop bit     */
  U1DLL = 195;                           /* 9600 Baud Rate @ 30MHz VPB Clock  */
  U1LCR = 0x03;                          /* DLAB = 0                          */
}

